
--INITIALIZATION--

local S = {}
local C = {}

local needscolor = M06_NEEDSCOLOR

skincolors[freeslot("SKINCOLOR_GODMODE")] = {
    name = "GodMode",
    ramp = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}, --placeholder
    invcolor = SKINCOLOR_WHITE, --placeholder
    invshade = 9,
    chatcolor = V_YELLOWMAP, --placeholder
    accessible = true
}

local checkintable = function(table, check)
	for k, v in ipairs(table) do
		if v == check
			return k
		end
	end
end


local function CheckifSupercolor(color)
    if not pcall(function(num) return skincolors[num] end, color) then return end
    if color then
        --print(skincolors[color].name)
        local counter = 0
        local check = 0
        for i = 0, 5
            counter = $+1
            if skincolors[color+i].name:sub(skincolors[color+i].name:len()) == tostring(counter) then
                check = $+1
            end
        end
        if check == 5 then
            return true
        end
    end
end

local counter = 0


for i = 1, #skincolors-1 do
    local county = 0
    county = $+1
    if CheckifSupercolor(i) then
        counter = $+1
        local clone = freeslot("SKINCOLOR_M06CLONE"..counter)
        local color = i
		local num = 1
		--print(skincolors[color].name:sub(skincolors[color].name:len()-1, skincolors[color].name:len()-1))
		--print(skincolors[color].name:sub(skincolors[color].name:len()-1, skincolors[color].name:len()-1))
		if skincolors[color].name:sub(skincolors[color].name:len()-1, skincolors[color].name:len()-1) == " " then
			num = 2
		end
        local name = skincolors[color].name:sub(1, skincolors[color].name:len()-num) --name without number
        skincolors[clone] = {
            name = name,--:gsub("%s+", "_"),
            ramp = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}, --placeholder
            invcolor = skincolors[color].invcolor or SKINCOLOR_GREY, --placeholder
            invshade = skincolors[color].invshade or 9,
            chatcolor = skincolors[color].chatcolor or 0, --placeholder
            accessible = true
        }
        local length = skincolors[color].name:len()
        table.insert(C, #C+1 or 1, clone)
        table.insert(S, clone, color)
        --print(S[clone] == color)
    end
end


local C = C
local S = S
--v + abs( ( (time >>1 % 9) - 4))

local function colors(time)
    for i = 1, #C do
        skincolors[C[i]].ramp = skincolors[S[C[i]] + abs( ( (time >>1 % 9) - 4))].ramp
    end
    skincolors[SKINCOLOR_GODMODE].ramp = skincolors[SKINCOLOR_SUPERSILVER1 + 5*( ( (time >> 1) % 7))].ramp
end

addHook("ThinkFrame", do colors(leveltime) end)
local intimer = 0
addHook("IntermissionThinker", do colors(intimer) intimer = $+1 end)

--COMMAND--

local function combinestrings(...)
    local values = {...}
    local string
    for k, v in ipairs(values)
        if not string then
            string = v
        else
            string = $.." "..v
        end
    end
    --print(string)
    return string
end

local checkintable = function(table, check)
	for k, v in ipairs(table) do
		if v == check
			return k
		end
	end
end

local function supercolorcheck(argument, oldcolor)
    if (argument == oldcolor)   or 
       (argument == oldcolor+1) or 
       (argument == oldcolor+2) or 
       (argument == oldcolor+3) or 
       (argument == oldcolor+4) then
        return argument-oldcolor
    end
end
local function applysupercolor(mo, player)
    if not player.m06 then return end
    if player.m06.supercolor == -1 then return end
    --if player.mo and (player.mo.skin == "pointy" or player.mo.skin == "fluffy") then return end
    local oldcolor = skins[mo.skin or 0].supercolor or SKINCOLOR_SUPERGOLD1
	if mo.color == FRACUNIT-1 then return end --?????????
    --if not oldcolor then return end
    if checkintable(C, player.m06.supercolor) then  
        if supercolorcheck(mo.color, oldcolor) != nil then
			if mo.skin and needscolor[mo.skin] then
				player.scolor = S[player.m06.supercolor] + abs( ( (player.powers[pw_super] >>1 % 9) - 4))
				mo.color = player.scolor
			else
				mo.color = S[player.m06.supercolor]+supercolorcheck($, oldcolor)
			end
        end
    else
        if supercolorcheck(mo.color, oldcolor) != nil then
			if mo.skin and needscolor[mo.skin] then
				player.scolor = S[player.m06.supercolor] + abs( ( (player.powers[pw_super] >>1 % 9) - 4))
				mo.color = player.m06.supercolor
			else
				mo.color = player.m06.supercolor
			end
        end
    end
end

addHook("PostThinkFrame", do
    for player in players.iterate
        if not player and player.mo and player.mo.valid then return end
        --if (player.pflags & PF_GODMODE) then return end
        if not player.m06 then
            player.m06 = {}
            --return
        end
        --print(player.mo.color)
        if player.m06.supercolor and player.m06.supercolor != -1 then
			applysupercolor(player.mo, player)
			if player.followmobj and player.followmobj.valid then
				applysupercolor(player.followmobj, player)
			end
		end
    end
end)


addHook("MobjThinker", function(mo)
	if (mo and mo.valid) and (mo.target and mo.target.valid) and (mo.target.player and mo.target.player.m06 and mo.target.player.m06.supercolor) then
		applysupercolor(mo, mo.target.player)
		return false
	end
end, MT_GHOST)

--MENU--

local supercolor_menu = {
    {-- page 1
        attributes = { -- different settings to modify
            pos = {30, 30}, -- 2-vector position
            header = {text = "Pick from...", color = V_AQUAMAP}, -- optional header with color
            start = {item = 1}, -- the cursor will be placed here when the menu enters this page
            previous = {page = -1, item = -1}, -- pressing ESC will lead to the previous page; if < 1 then the menu closes
            style = MMT_NORMAL -- there are 3 style types; this is the normal style imitating vanilla srb2 menus
        },
        functions = {
            handler = nil, -- runs when a key is pressed, doesn't override default keyevents; use this for custom keypresses as an expansion
            ticker = nil, -- runs when this page is active; don't put logic that can actually affect the netcode
            drawer = nil, -- runs when the style is MMT_CUSTOM, is possible to make a hybrid with custom and normal/scroll styles
        },
        content = {
            {id = MIT_STRING, flags = MIF_FUNCTION, string = "Super Colors", color = 0, func = function() LM_GoToPage(2) end, cvar = nil, pos_y = 0},
            {id = MIT_STRING, flags = MIF_FUNCTION, string = "Normal Colors", color = 0, func = function() LM_GoToPage(3) end, cvar = nil, pos_y = 10}
        }
    },

    { -- page 2
		attributes = { -- different settings to modify
			pos = {30, 30}, -- 2-vector position
			header = {text = "Super Colors", color = V_ROSYMAP}, -- optional header with color
			start = {item = 1}, -- the cursor will be placed here when the menu enters this page
			previous = {page = 1, item = 1}, -- pressing ESC will lead to the previous page; if < 1 then the menu closes
			style = MMT_SCROLL -- there are 3 style types; this is the normal style imitating vanilla srb2 menus
		},
		functions = {
			handler = nil, -- runs when a key is pressed, doesn't override default keyevents; use this for custom keypresses as an expansion
			ticker = nil, -- runs when this page is active; don't put logic that can actually affect the netcode
			drawer = nil, -- runs when the style is MMT_CUSTOM, is possible to make a hybrid with custom and normal/scroll styles
		},
		content = {}
	},

	{ -- page 3
		attributes = { -- different settings to modify
			pos = {30, 30}, -- 2-vector position
			header = {text = "Normal Colors", color = V_ROSYMAP}, -- optional header with color
			start = {item = 1}, -- the cursor will be placed here when the menu enters this page
			previous = {page = 1, item = 2}, -- pressing ESC will lead to the previous page; if < 1 then the menu closes
			style = MMT_SCROLL -- there are 3 style types; this is the normal style imitating vanilla srb2 menus
		},
		functions = {
			handler = nil, -- runs when a key is pressed, doesn't override default keyevents; use this for custom keypresses as an expansion
			ticker = nil, -- runs when this page is active; don't put logic that can actually affect the netcode
			drawer = nil, -- runs when the style is MMT_CUSTOM, is possible to make a hybrid with custom and normal/scroll styles
		},
		content = {}
	}
}



for i = 1, #C do
	supercolor_menu[2].content[i] = {
		id = MIT_STRING,
		flags = MIF_FUNCTION,
		string = skincolors[C[i]].name,
		color = skincolors[C[i]].chatcolor or 0,
		func = function() 
			COM_BufInsertText(consoleplayer, "supercolor "..skincolors[C[i]].name..";".."supercolor playsound "..sfx_strpst)
			--supercolor_menu[10].attributes.start.item = nil
			--LM_GoToPage(1) 
		end,
		cvar = nil,
		colorcheck = true,
		constant = C[i],
		pos_y = 2+(10*i)
	}
end

local normalcolors = {}

for i = 1, #skincolors-1 do
	if skincolors[i].accessible and (not checkintable(C, i)) then
		table.insert(normalcolors, i)
	end
end 



for i = 1, #normalcolors do
	--if not pcall(function(e) assert(skincolors[e]) end, i) then continue end
	supercolor_menu[3].content[i] = {
		id = MIT_STRING,
		flags = MIF_FUNCTION,
		string = skincolors[normalcolors[i]].name or "Color",
		color = skincolors[normalcolors[i]].chatcolor or 0,
		func = function()
			COM_BufInsertText(consoleplayer, "supercolor "..skincolors[normalcolors[i]].name..";".."supercolor playsound "..sfx_strpst)
			--supercolor_menu[11].attributes.start.item = nil
			--LM_GoToPage(9) 
		end,
		cvar = nil,
		colorcheck = true,
		constant = normalcolors[i],
		pos_y = 2+(10*i)
	}
end

local function SupercolorHUD(v, skin, color, boolean)
	local colormap = v.getColormap(#skins[skin], color)
	local overalls = v.getColormap(#skins[skin], SKINCOLOR_WHITE)
	local sprite = v.getSprite2Patch(skin, SPR2_XTRA, (not (skins[skin].flags & SF_NOSUPERSPRITES)), A, 2)
	--local secondsprite = v.getSprite2Patch(player.mo.skin, SPR2_STND, true, A, 2)
	local flags = V_SNAPTOTOP
	local x = 220
	local y = 100
	local multiplier = (1+(6/10))
	local scale = FixedDiv(skins[skin].highresscale, skins[skin].shieldscale)
	if boolean then
		scale = FRACUNIT
		sprite = v.getSprite2Patch(skin, SPR2_XTRA, false, A, 2)
	end
	if select(2, sprite)
		flags = $|V_FLIP
	else
		flags = V_SNAPTOTOP
	end
	v.drawScaled(FRACUNIT*x, FRACUNIT*y+b, scale*multiplier, v.cachePatch("STLIVEBK"), flags, nil)
	v.drawScaled(FRACUNIT*x, FRACUNIT*y+b, scale*multiplier, select(1, sprite), flags, colormap)
end

hud.add(function(v)
	if lmenu.current != supercolor_menu then return end
	if (lmenu.page == 2) or (lmenu.page == 3) then
		SupercolorHUD(v, (displayplayer.mo.skin or "sonic"), lmenu.current[lmenu.page].content[lmenu.cursor].constant or SKINCOLOR_NONE)
    end
end, "game")

COM_AddCommand("supercolor", function(player, ...)
	if player
		if not ...
			CONS_Printf(player,"Changes your supercolor to any skincolor 'supercolor <color/default>'")
			return
		end
        if not player.m06 then
            player.m06 = {}
        end
        local arg = combinestrings(...)
        local args = {...}
		if arg == "default"
			player.m06.supercolor = -1
			CONS_Printf(player,"Supercolor set to default")
			return
		end
        if args[1] == "playsound"
            S_StartSound(nil, tonumber(args[2]), player)
            return
        end
		if R_GetColorByName(arg) != SKINCOLOR_NONE
			player.m06.supercolor = R_GetColorByName(arg)
			CONS_Printf(player,"Supercolor set to "..R_GetNameByColor(player.m06.supercolor))			
		elseif R_GetSuperColorByName(arg) != SKINCOLOR_NONE
            player.m06.supercolor = R_GetSuperColorByName(arg)
            CONS_Printf(player,"Supercolor set to "..R_GetNameByColor(player.m06.supercolor))			
        else
            CONS_Printf(player,"That color does not exist, please enter a skincolor name, or just 'default' to reset")
		end
	end
end)

COM_AddCommand("supercolor_menu", do
	LM_OpenMenu(supercolor_menu, 1)
end, COM_LOCAL)